var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { useToast, Button as B, } from '@chakra-ui/react';
import * as c from '@chakra-ui/react';
import { random, useDeep } from '@deep-foundation/deeplinks';
import { Subscription, Query } from '@deep-foundation/deeplinks/imports/client.js';
import EventEmitter from 'events';
import isEqual from 'lodash/isEqual.js';
import React, { createContext, memo, useCallback, useContext, useEffect, useMemo, useRef, useState } from 'react';
import { useHotkeys } from 'react-hotkeys-hook';
import { HandlerConfigContext, HandlersGoContext, useClientHandler, useHandlersGo } from './client-handler.js';
import { ReactHandler } from './react-handler.js';
import { MdSaveAlt } from 'react-icons/md';
import { useCookiesStore } from '@deep-foundation/store/cookies.js';
import { useLocalStore } from '@deep-foundation/store/local.js';
import { useQueryStore } from '@deep-foundation/store/query.js';
import { getChakraVar, loader, useChakraColor, useHandlersContext, useLoader, usePreload } from './hooks.js';
import { useAsyncMemo } from "use-async-memo";
const dpl = '@deep-foundation/perception-links';
const dc = '@deep-foundation/core';
const dtsx = '@deep-foundation/tsx';
export const GoCustomContext = createContext({});
export function GoCustomProvider({ value, children = null }) {
    return React.createElement(GoCustomContext.Provider, { value: value }, children);
}
export const GoContext = createContext(undefined);
GoContext.displayName = 'GoContext';
export function useGoCore(context) { return useContext(context || GoContext); }
export const ValueContext = createContext(undefined);
let _i = 0;
let _p = 0;
export const GoEditorContext = createContext(undefined);
export const GoEditorProvider = memo(function GoEditorProvider({ Editor, children }) {
    return React.createElement(GoEditorContext.Provider, { value: Editor }, children);
});
export const GoProvider = memo(function GoProvider({ linkId, value: _value, on, context = GoContext, children = null, hotkeys = false, }) {
    var _a, _b;
    const Editor = useContext(GoEditorContext);
    const deep = useDeep();
    const __p = useMemo(() => { return _p++; }, []);
    const _parentGo = useGoCore(context);
    const hgo = useGoCore(HandlersGoContext);
    const stateContext = useState(_value);
    const selectedValue = linkId ? stateContext : [_parentGo.value, _parentGo._setValue];
    const [value, setValue] = useMemo(() => selectedValue, [selectedValue]);
    const ref = useRef();
    const childrenRef = useRef({});
    const parentRef = useRef(_parentGo);
    const valueRef = useRef(value);
    const isChanged = value !== valueRef.current || _parentGo !== parentRef.current;
    valueRef.current = value;
    parentRef.current = _parentGo;
    const pgoRef = useRef();
    const __actualGoRef = useRef(_parentGo);
    const custom = useContext(GoCustomContext) || {};
    const { go, parentGo } = useMemo(() => {
        const _go = (linkId ? function go(path) { return _go._go(path); } : _parentGo);
        if (linkId) {
            _go._i = _i++;
            _go.__p = __p;
            _go.go = _parentGo;
            _go.ref = ref;
            _go.children = childrenRef.current;
            if (_parentGo)
                _parentGo.children[linkId] = _go;
            _go.data = {};
        }
        else {
            _go.ref = _parentGo.ref;
            _go.children = _parentGo.children;
            _go.data = _parentGo.data;
        }
        return { go: _go, parentGo: _parentGo };
    }, [value, _parentGo]);
    go.emitter = useMemo(() => {
        const e = linkId ? go.emitter || new EventEmitter() : parentGo.emitter;
        return e;
    }, []);
    useEffect(() => {
        return () => {
        };
    }, []);
    const toast = useToast();
    const _loader = useCallback((query) => loader({ query, deep }), []);
    useMemo(() => {
        var _a, _b;
        const pgo = pgoRef.current;
        go.linkId = linkId || parentGo.linkId;
        go.link = (_a = deep === null || deep === void 0 ? void 0 : deep.minilinks) === null || _a === void 0 ? void 0 : _a.byId[go.linkId];
        go.context = context;
        go.path = linkId ? `${parentGo ? parentGo.path + '.' : ''}${linkId}` : parentGo.path;
        go.value = value;
        go.go = linkId ? parentGo : parentGo === null || parentGo === void 0 ? void 0 : parentGo.go;
        go._go = _go;
        go.current = (_b = go === null || go === void 0 ? void 0 : go.children) === null || _b === void 0 ? void 0 : _b[value];
        go.deep = deep;
        go.log = log;
        go.scroll = scroll;
        go.toString = toString;
        go.save = save;
        go.Save = Save;
        go.Provider = GoProvider;
        go.Handler = Handler;
        go.Input = Input;
        go.Editor = Editor;
        go.Subscription = Subscription;
        go.Query = Query;
        go.useLocalStore = useLocalStore;
        go.useQueryStore = useQueryStore;
        go.useCookiesStore = useCookiesStore;
        go.getChakraVar = getChakraVar;
        go.useChakraColor = useChakraColor;
        go.HandlerConfigContext = HandlerConfigContext;
        go.Component = Component;
        go.Button = Button;
        go.useHook = useHook;
        go.useLoader = useLoader;
        go.loader = _loader;
        go.On = On;
        go.on = _on;
        go.emit = emit;
        go.noScrollBar = noScrollBar;
        go.do = _do;
        go.useGo = useGo;
        go.useNav = useNav;
        go.parents = parents;
        go.parent = parent;
        go.focused = focused;
        go.root = root;
        go.await = _await;
        go.awaitRef = _awaitRef;
        go.all = all;
        go.activator = activator;
        go.next = next;
        go.prev = prev;
        go.delay = delay;
        go.useRefValue = useRefValue;
        go._setValue = setValue;
        go.hgo = hgo;
        go.__go = parentGo;
        go.__actualGoRef = (linkId ? __actualGoRef : parentGo === null || parentGo === void 0 ? void 0 : parentGo.__actualGoRef) || __actualGoRef;
        for (let c in custom) {
            go[c] = custom[c];
        }
        go.componentTemplate = componentTemplate;
        go.hookTemplate = hookTemplate;
    }, [go, value, deep]);
    const _set = useCallback((_value, ...args) => {
        var _a, _b;
        go.value = _value;
        if ((_a = go.children) === null || _a === void 0 ? void 0 : _a[go.value]) {
            go.current = (_b = go.children) === null || _b === void 0 ? void 0 : _b[go.value];
        }
        if (value === _value)
            return { go };
        setValue(_value);
        return { go };
    }, [go, value]);
    const _setRef = useRef(_set);
    _setRef.current = _set;
    const _focus = useCallback((_value, ...args) => {
        var _a, _b, _c, _d, _e;
        go.value = _value;
        if ((_a = go.children) === null || _a === void 0 ? void 0 : _a[go.value]) {
            go.current = (_b = go.children) === null || _b === void 0 ? void 0 : _b[go.value];
            go.children[go.value].do('focus', undefined, ...args);
        }
        const parents = go.parents();
        for (let p = 1; p < parents.length; p++) {
            if (((_c = parents[p]) === null || _c === void 0 ? void 0 : _c.value) != ((_d = parents[(+p) - 1]) === null || _d === void 0 ? void 0 : _d.linkId))
                parents[p].set(((_e = parents[(+p) - 1]) === null || _e === void 0 ? void 0 : _e.linkId));
        }
        go.emit('focus', _value, ...args);
        if (value === _value)
            return { go };
        setValue(_value);
        return { go };
    }, [go, value]);
    const _focusRef = useRef(_focus);
    _focusRef.current = _focus;
    useMemo(() => {
        go.set = linkId ? function set(value, ...args) {
            return _setRef.current(value, ...args);
        } : parentGo === null || parentGo === void 0 ? void 0 : parentGo.set;
        go.focus = linkId ? function focus(value, ...args) {
            return _focusRef.current(value, ...args);
        } : parentGo === null || parentGo === void 0 ? void 0 : parentGo.focus;
    }, [go, parentGo, value]);
    pgoRef.current = go;
    if ((go === null || go === void 0 ? void 0 : go._i) > ((_b = (_a = go.__actualGoRef) === null || _a === void 0 ? void 0 : _a.current) === null || _b === void 0 ? void 0 : _b._i) || !go.__actualGoRef.current)
        go.__actualGoRef.current = go;
    return React.createElement(context.Provider, { key: __p, value: go },
        React.createElement(On, Object.assign({}, on)),
        !parentGo && hotkeys && React.createElement(Hotkeys, { context: context }),
        children);
}, isEqual);
function Hotkeys({ context }) {
    const deep = useDeep();
    const go = useGoCore(context);
    useEffect(() => {
    }, [go]);
    useHotkeys('up,down,right,left,space,enter,shift+up,shift+down,shift+right,shift+left,shift+space,shift+enter,meta+down,meta+right,meta+left,meta+space,meta+enter,ctrl+down,ctrl+right,ctrl+left,ctrl+space,ctrl+enter', (e, h) => __awaiter(this, void 0, void 0, function* () {
        const fs = go.root().focused();
        const ids = fs.map(f => f.linkId);
        const f = fs.pop();
        if (f)
            f.do(h.keys[0], { keyboardEvent: e, hotkeyEvent: h });
    }), { preventDefault: true, enableOnFormTags: false }, [go]);
    return null;
}
const On = function On(on) {
    const Go = useGo();
    const offsRef = useRef([]);
    const onsRef = useRef({});
    onsRef.current.on = on;
    useMemo(() => {
        const go = Go();
        const offs = offsRef.current;
        const ons = onsRef;
        for (let l in offs)
            offs[l]();
        if (on) {
            for (let name in on) {
                for (let a in on[name]) {
                    const { off } = go.on(name, a, (...args) => { var _a, _b, _c, _d, _e, _f, _g, _h; return ((_d = (_c = (_b = (_a = args.slice(-1)[0]) === null || _a === void 0 ? void 0 : _a.current) === null || _b === void 0 ? void 0 : _b.on) === null || _c === void 0 ? void 0 : _c[name]) === null || _d === void 0 ? void 0 : _d[a]) && ((_h = (_g = (_f = (_e = args.slice(-1)[0]) === null || _e === void 0 ? void 0 : _e.current) === null || _f === void 0 ? void 0 : _f.on) === null || _g === void 0 ? void 0 : _g[name]) === null || _h === void 0 ? void 0 : _h[a](...args.slice(0, -1))); }, onsRef);
                    offs.push(off);
                }
            }
        }
    }, []);
    useEffect(() => {
        return () => {
            const offs = offsRef.current;
            for (let l in offs)
                offs[l]();
        };
    }, []);
    return (on === null || on === void 0 ? void 0 : on.children) || null;
};
const delay = (time) => new Promise((res) => setTimeout(() => res(true), time));
function useRefValue(value) {
    const ref = useRef(value);
    ref.current = value;
    return ref;
}
;
const _on = function on(name, value, handler, onsRef) {
    const go = this();
    const listener = (g, v, ...args) => {
        var _a;
        const vl = go.deep.minilinks.byId[v];
        const vlc = go.deep.minilinks.byId[go.value];
        handler(g, v, ...args, onsRef);
        console.log(`{ ${g.link} } go.${name}() ${go.link}(${(_a = go === null || go === void 0 ? void 0 : go.link) === null || _a === void 0 ? void 0 : _a.type}): ${vlc ? `${vlc}(${vlc === null || vlc === void 0 ? void 0 : vlc.type})` : go.value} > ${vl ? `${vl}(${vl === null || vl === void 0 ? void 0 : vl.type})` : v}`, args);
    };
    const emitter = go.emitter.on(`${name}.${value}`, listener);
    const off = () => go.emitter.removeListener(`${name}.${value}`, listener);
    return { go, emitter, name, value, listener, off };
};
const emit = function emit(name, value, ...args) {
    const go = this();
    const ps = go.parents();
    for (let p in ps) {
        const result = ps[p].emitter.emit(`${name}.${value}`, go, value, ...args);
        if (result)
            return result;
    }
    return false;
};
const _do = function _do(value, ...args) {
    const go = this();
    go.emit('do', value, ...args);
    if (value === 'enter' || value === 'space')
        go.emit('do', 'exec', ...args);
    return { go };
};
const parents = function parents() {
    const go = this();
    let root, target, pointer = go, parents = [];
    while (!root) {
        parents.push(pointer);
        if (pointer.go)
            pointer = pointer.go;
        else
            root = pointer;
    }
    return parents;
};
const parent = function parent(id) {
    const go = this();
    const parents = go.parents();
    for (let i = 0; i < parents.length - 1; i++) {
        if (parents[i].linkId == id)
            return parents[i];
    }
};
const all = function all(path) {
    var _a;
    const go = this();
    let pointer = go;
    const steps = path.split('.');
    const data = [pointer];
    for (let s in steps) {
        const next = (_a = pointer === null || pointer === void 0 ? void 0 : pointer.children) === null || _a === void 0 ? void 0 : _a[steps[s]];
        if (next)
            data.push(next);
        else
            break;
    }
    return { steps, data };
};
export function useGo() {
    return useGoCore((this === null || this === void 0 ? void 0 : this.context) || GoContext);
}
function activator(state, mustbe, ifthen = 'active', elsethen = undefined, prop = 'variant') {
    return { [prop]: isEqual(state[0], mustbe) ? ifthen : elsethen, onClick: () => state[1](mustbe), children: mustbe };
}
function prev(list) {
    var _a;
    const go = this();
    const v = arguments.length === 2 ? arguments[1] : go.value;
    if (!Array.isArray(list))
        return null;
    const i = list.findIndex(l => l.id === v);
    const ni = (_a = (!~i || i == 0 ? list[list.length - 1] : list[i - 1])) === null || _a === void 0 ? void 0 : _a.id;
    return ni;
}
function next(list) {
    var _a;
    const go = this();
    const v = arguments.length === 2 ? arguments[1] : go.value;
    if (!Array.isArray(list))
        return null;
    const i = list.findIndex(l => l.id === v);
    const ni = (_a = (!~i || i == list.length - 1 ? list[0] : list[i + 1])) === null || _a === void 0 ? void 0 : _a.id;
    return ni;
}
function useNav() {
    const ref = useRef({});
    const nav = useCallback((name, left, up, right, down) => { ref.current[name] = { left, up, right, down }; }, []);
    nav.get = useCallback((from, to) => {
        var _a, _b;
        return ((_b = (_a = ref.current) === null || _a === void 0 ? void 0 : _a[from]) === null || _b === void 0 ? void 0 : _b[to]) || 'current';
    }, []);
    nav.map = ref.current;
    return nav;
}
function root() {
    const go = this();
    return (go === null || go === void 0 ? void 0 : go.go) ? go === null || go === void 0 ? void 0 : go.go.root() : go;
}
function focused() {
    var _a, _b;
    return [this, ...((this === null || this === void 0 ? void 0 : this.value) && ((_a = this === null || this === void 0 ? void 0 : this.children) === null || _a === void 0 ? void 0 : _a[this === null || this === void 0 ? void 0 : this.value]) ? (_b = this === null || this === void 0 ? void 0 : this.children) === null || _b === void 0 ? void 0 : _b[this === null || this === void 0 ? void 0 : this.value].focused() : [])];
}
function log(value) {
    if (value)
        console.log(value);
    console.dir(this);
}
function scroll(options = { block: "center", inline: "center", behavior: 'smooth' }) {
    var _a, _b, _c, _d;
    const go = this();
    (_d = (((_a = go.ref) === null || _a === void 0 ? void 0 : _a.current) || ((_c = (_b = go === null || go === void 0 ? void 0 : go.hgo()) === null || _b === void 0 ? void 0 : _b.ref) === null || _c === void 0 ? void 0 : _c.current))) === null || _d === void 0 ? void 0 : _d.scrollIntoView(options);
    return { go };
}
function _go(path) {
    if (typeof (path) === 'function')
        return path(this);
    const go = this.__actualGoRef.current;
    if (!path)
        return go;
    const _path = `${path}`;
    const { data, steps } = go.all(_path);
    if (steps.length > data.length + 1 || data[data.length - 1].linkId != steps[steps.length - 1])
        return null;
    else
        return data[data.length - 1];
}
function toString() {
    var _a;
    return `p${this.__p} i${this._i} ${this.link} ${((_a = this.current) === null || _a === void 0 ? void 0 : _a.link) || this.value}`;
}
function Save({ handlerId }) {
    const go = useGoCore();
    useEffect(() => { go.save(handlerId); }, [handlerId]);
}
function __await(_go, id, check, result = check) {
    return __awaiter(this, void 0, void 0, function* () {
        return new Promise((res, rej) => {
            let count = 0;
            const i = setInterval(() => {
                const go = _go();
                if (check(go)) {
                    clearInterval(i);
                    res(result(go));
                }
                else if (count++ > 30)
                    rej(`${go} await(${id}) not rejected`);
            }, 100);
        });
    });
}
function _await(id) {
    return __awaiter(this, void 0, void 0, function* () {
        return __await(this(), id, (go) => { var _a; return (_a = go.children) === null || _a === void 0 ? void 0 : _a[id]; });
    });
}
function _awaitRef(id) {
    return __awaiter(this, void 0, void 0, function* () {
        return __await(this(), id, (go) => { var _a, _b, _c; return (_c = (_b = (_a = go.children) === null || _a === void 0 ? void 0 : _a[id]) === null || _b === void 0 ? void 0 : _b.ref) === null || _c === void 0 ? void 0 : _c.current; }, (go) => { var _a; return (_a = go.children) === null || _a === void 0 ? void 0 : _a[id]; });
    });
}
function save(handlerId) {
    return __awaiter(this, void 0, void 0, function* () {
        const go = this();
        const deep = go.deep;
        const { data: [history] } = yield deep.select({
            from_id: deep.linkId,
            type_id: deep.idLocal(dpl, 'History'),
            to_id: go.linkId,
            order_by: { id: 'desc' },
            limit: 1,
        });
        if (!go._inserted && !history) {
            go._inserted = true;
            const { data: [h] } = yield go.deep.insert({
                type_id: deep.idLocal(dpl, 'History'),
                from_id: deep.linkId,
                to_id: go.linkId,
                containerId: deep.linkId,
                string: `${go.value}`,
                out: {
                    type_id: deep.idLocal(dpl, 'HistoryHandler'),
                    to_id: handlerId,
                    containerId: deep.linkId,
                },
            });
            go._inserted = h;
        }
        else if (typeof (go._inserted) === 'number') {
            return go.deep.value((history === null || history === void 0 ? void 0 : history.id) || go._inserted, `${go.value}`);
        }
    });
}
export const noScrollBar = ((s) => ({
    '&::-webkit-scrollbar': s,
    '&::-webkit-scrollbar-track': s,
    '&::-webkit-scrollbar-thumb': s,
    'scrollbar-width': 'none !important',
}))({ display: 'none' });
const componentTemplate = ({ children } = { children: null }) => `({ deep, data, require, Go }) => {
  const React = require('react');
  const c = require('@chakra-ui/react');
  
  const dc = '@deep-foundation/core';
  const dpl = '@deep-foundation/perception-links';

  return ({
    go,
    goHandler,

    handlerId,
    Component,

    linkId,
    link,

    children,

    isActive,

    ...props
  }, ref) => {
    return <go.On
      do={{
      }}
    >
      ${!!children ? children : `<c.Box ref={ref} h='3em'>{\`\$\{go\}\`}</c.Box>`}
    </go.On>;
  };
}`;
componentTemplate.toString = () => componentTemplate();
const hookTemplate = () => `({ deep, data, require, Go }) => {
  const React = require('react');

  return function() {
    const go = Go.useGo();
    const rerendersRef = React.useRef(0);
    return React.useMemo(() => ++rerendersRef.current);
  };
}`;
hookTemplate.toString = () => hookTemplate();
const useHook = function useHook({ path, extendInsert = {}, postfix = 'Hook' }) {
    const go = useGoCore();
    const [isPreloaded, repreload] = usePreload();
    const deep = useDeep();
    const [name] = useState(random());
    const [handlerId, setHandlerId] = useState();
    const [links, setLinks] = useState({ data: [] });
    deep.useMinilinksApply(name, links);
    const { data: _hook } = useClientHandler({ handlerId });
    (typeof (_hook) === 'function' && _hook.name !== deep.nameLocal(handlerId)) && Object.defineProperty(_hook, "name", { value: deep.nameLocal(handlerId) });
    const handlersRef = useHandlersContext();
    useEffect(() => {
        var _a;
        if ((_a = links === null || links === void 0 ? void 0 : links.data) === null || _a === void 0 ? void 0 : _a.length)
            try {
                localSelectHandlerId(deep, path, handlerId, setHandlerId, handlersRef.current);
            }
            catch (e) { }
    }, [links]);
    useMemo(() => {
        try {
            localSelectHandlerId(deep, path, handlerId, setHandlerId, handlersRef.current);
        }
        catch (e) {
            selectHandler(path, go, deep, setLinks, hookTemplate(), extendInsert, postfix).then(() => repreload());
        }
    }, []);
    return _hook;
};
let _ComponentInserted = {};
const selectHandler = (path, go, deep, setLinks, template, extendInsert, postfix) => __awaiter(void 0, void 0, void 0, function* () {
    var _a, _b, _c, _d, _e, _f, _g;
    const results = yield deep.select(go.loader({ id: { _id: [...path] }, return: { code: { relation: 'to' } } }));
    if (!((_a = results === null || results === void 0 ? void 0 : results.data) === null || _a === void 0 ? void 0 : _a[0]))
        return yield insertHandler(path, go, deep, setLinks, template, extendInsert, postfix);
    else if ((_c = (_b = results === null || results === void 0 ? void 0 : results.data) === null || _b === void 0 ? void 0 : _b[0]) === null || _c === void 0 ? void 0 : _c.code) {
        setLinks(results);
        return (_e = (_d = results === null || results === void 0 ? void 0 : results.data) === null || _d === void 0 ? void 0 : _d[0]) === null || _e === void 0 ? void 0 : _e.id;
    }
    else
        return yield insertCode(path, go, deep, setLinks, (_g = (_f = results === null || results === void 0 ? void 0 : results.data) === null || _f === void 0 ? void 0 : _f[0]) === null || _g === void 0 ? void 0 : _g.id, template, extendInsert, postfix);
});
const insertHandler = (path, go, deep, setLinks, template, extendInsert, postfix) => __awaiter(void 0, void 0, void 0, function* () {
    const containerId = yield deep.id(...path.slice(0, -1));
    const last = path[path.length - 1];
    if (_ComponentInserted[`${path.join(',')}`]) {
        yield go.delay(300);
        return yield selectHandler(path, go, deep, setLinks, template, extendInsert, postfix);
    }
    else {
        _ComponentInserted[`${path.join(',')}`] = true;
        const { data: [{ id }] } = yield deep.insert(Object.assign({ type_id: deep.idLocal(dc, 'Handler'), from_id: deep.idLocal(dc, 'clientSupportsJs'), containerId: containerId, name: typeof (last) === 'string' ? last : undefined, to: {
                type_id: deep.idLocal(dtsx, 'TSX'),
                string: template,
                containerId: containerId,
                name: typeof (last) === 'string' ? `${last}${postfix}` : undefined,
            } }, extendInsert));
        return yield selectHandler([id], go, deep, setLinks, template, extendInsert, postfix);
    }
});
const insertCode = (path, go, deep, setLinks, handlerId, template, extendInsert, postfix) => __awaiter(void 0, void 0, void 0, function* () {
    const { data: [{ id }] } = yield deep.insert({
        type_id: deep.idLocal(dtsx, 'TSX'),
        string: template,
        containerId: yield deep.id(...path.slice(0, -1)),
        name: typeof (path[path.length - 1]) === 'string' ? `${path[path.length - 1]}${postfix}` : undefined,
    });
    yield deep.update({ id: handlerId }, { to_id: id });
    return yield selectHandler(path, go, deep, setLinks, template, extendInsert, postfix);
});
const localSelectHandlerId = (deep, path, handlerId, setHandlerId, handlers) => {
    let id, handler, code;
    if (handlerId)
        return;
    id = deep.idLocal(...path);
    handler = deep.minilinks.byId[id];
    const localHandler = (handlers || []).find(h => h.handler_id === id);
    code = localHandler === null || localHandler === void 0 ? void 0 : localHandler.dist;
    if (handler && code)
        setHandlerId(id);
    else
        throw new Error('no local handler');
};
const Handler = memo(function Handler(_a) {
    var { provide = false, handlerId, linkId, on } = _a, props = __rest(_a, ["provide", "handlerId", "linkId", "on"]);
    const go = useGoCore();
    const handler = React.createElement(ReactHandler, Object.assign({ handlerId: handlerId, linkId: linkId }, props));
    return provide ? React.createElement(go.Provider, { linkId: linkId || handlerId, on: on }, handler) : handler;
});
const Component = memo(function Component(_a) {
    var { path, linkId, extendInsert = {}, provide = false, on, postfix = 'Component' } = _a, props = __rest(_a, ["path", "linkId", "extendInsert", "provide", "on", "postfix"]);
    const go = useGoCore();
    const [isPreloaded, repreload] = usePreload();
    const deep = useDeep();
    const [name] = useState(random());
    const [handlerId, setHandlerId] = useState();
    const handlersRef = useHandlersContext();
    const [links, setLinks] = useState({ data: [] });
    deep.useMinilinksApply(links, name);
    useEffect(() => {
        var _a;
        if ((_a = links === null || links === void 0 ? void 0 : links.data) === null || _a === void 0 ? void 0 : _a.length)
            try {
                localSelectHandlerId(deep, path, handlerId, setHandlerId, handlersRef.current);
            }
            catch (e) { }
    }, [links]);
    useMemo(() => {
        try {
            localSelectHandlerId(deep, path, handlerId, setHandlerId, handlersRef.current);
        }
        catch (e) {
            console.log('Component local error', e);
            selectHandler(path, go, deep, setLinks, componentTemplate(), extendInsert, postfix).then(() => repreload()).catch(e => {
                console.log('Component remote error', e);
            });
        }
    }, []);
    return !!handlerId ? (provide ? React.createElement(go.Provider, { linkId: handlerId, on: on },
        React.createElement(go.Handler, Object.assign({ handlerId: handlerId, linkId: linkId }, props))) : React.createElement(go.Handler, Object.assign({ handlerId: handlerId, linkId: linkId }, props))) : null;
}, isEqual);
const Button = memo(function Button(props) {
    const go = useGoCore();
    const hgo = useHandlersGo();
    return React.createElement(B, Object.assign({ ref: hgo.ref, variant: (props === null || props === void 0 ? void 0 : props.isActive) ? 'active' : undefined, onClick: () => go.do('exec', { id: go.linkId }) }, props));
}, isEqual);
const Input = React.memo((_a) => {
    var _b;
    var { path, insert, title, type = 'string' } = _a, props = __rest(_a, ["path", "insert", "title", "type"]);
    const deep = useDeep();
    const { name, containerId } = useAsyncMemo(() => __awaiter(void 0, void 0, void 0, function* () {
        return ({
            name: (path || []).slice(-1)[0],
            containerId: yield deep.id((path || []).slice(0, -1)),
        });
    }), [path], {});
    const insertedRef = React.useRef(false);
    const skip = !(path && containerId);
    const { data: [link], loading } = deep.useSubscription(skip ? {} : {
        id: { _id: [containerId, name] },
    }, { skip });
    const [v, setV] = React.useState('');
    const [saving, setSaving] = React.useState(false);
    return React.createElement(React.Fragment, null,
        !!title && React.createElement(c.Box, { color: 'deepColor' }, title),
        React.createElement(c.InputGroup, { position: 'relative' },
            React.createElement(c.Input, Object.assign({ value: v, onChange: (e) => { var _a; return setV((_a = e === null || e === void 0 ? void 0 : e.target) === null || _a === void 0 ? void 0 : _a.value); }, h: '3em' }, props)),
            !!link && React.createElement(c.Text, { position: 'absolute', left: '1.4em', bottom: '0.1em', pointerEvents: 'none', fontSize: 'xs', noOfLines: 1, color: 'deepColorDisabled' }, `${((_b = link === null || link === void 0 ? void 0 : link.value) === null || _b === void 0 ? void 0 : _b.value) || ''}`),
            React.createElement(c.InputRightElement, { h: '3em', w: '3em' },
                React.createElement(c.Button, { h: '3em', w: '3em', isLoading: saving, isDisabled: props === null || props === void 0 ? void 0 : props.isDisabled, onClick: () => __awaiter(void 0, void 0, void 0, function* () {
                        if (loading)
                            return;
                        setSaving(true);
                        if (!link && !insertedRef.current) {
                            insertedRef.current = true;
                            if (!insert)
                                return;
                            const { data: [inserted] } = yield deep.insert(Object.assign({ containerId, name, [type]: type === 'number' ? +v : v }, insert));
                        }
                        else if (!!link) {
                            yield deep.value(link.id, v);
                        }
                        setSaving(false);
                    }) },
                    React.createElement(MdSaveAlt, null)))));
}, isEqual);
//# sourceMappingURL=go.js.map