var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { useTheme } from '@chakra-ui/react';
import { useDeep } from "@deep-foundation/deeplinks";
import React, { createContext, useCallback, useContext, useEffect, useMemo, useRef, useState } from 'react';
import { GoEditorProvider, useGoCore } from './go.js';
export function Packages() {
    const deep = useDeep();
    deep.useSubscription({
        type_id: { _nin: [
                deep.idLocal('@deep-foundation/core', 'Promise'),
                deep.idLocal('@deep-foundation/core', 'Then'),
                deep.idLocal('@deep-foundation/core', 'Rejected'),
                deep.idLocal('@deep-foundation/core', 'Resolved'),
                deep.idLocal('@deep-foundation/core', 'PromiseResult'),
            ] },
        up: {
            tree_id: { _eq: deep.idLocal('@deep-foundation/core', 'containTree') },
            parent: {
                type_id: { _eq: deep.idLocal('@deep-foundation/core', 'Package') },
                string: { value: { _neq: 'deep' } },
            },
        },
    });
    return null;
}
export const PreloadContext = createContext(undefined);
export function usePreload() { return useContext(PreloadContext); }
export const HandlersContext = createContext([]);
export function useHandlersContext() { return useContext(HandlersContext); }
export function PreloadProviderCore({ preloaded = {}, children = null, }) {
    var _a, _b;
    const deep = useDeep();
    const [handlers, setHandlers] = useState((preloaded === null || preloaded === void 0 ? void 0 : preloaded.handlers) || []);
    useMemo(() => {
        deep.minilinks.add((preloaded === null || preloaded === void 0 ? void 0 : preloaded.packages) || [], 'preloader-packages');
    }, []);
    const [isPreloaded, setIsPreloaded] = useState(!!((_b = (_a = deep === null || deep === void 0 ? void 0 : deep.minilinks) === null || _a === void 0 ? void 0 : _a.links) === null || _b === void 0 ? void 0 : _b.length));
    const reload = useCallback(() => __awaiter(this, void 0, void 0, function* () {
        deep.minilinks.apply(yield deep.select({
            type_id: { _nin: [
                    deep.idLocal('@deep-foundation/core', 'Promise'),
                    deep.idLocal('@deep-foundation/core', 'Then'),
                    deep.idLocal('@deep-foundation/core', 'Rejected'),
                    deep.idLocal('@deep-foundation/core', 'Resolved'),
                    deep.idLocal('@deep-foundation/core', 'PromiseResult'),
                ] },
            up: {
                tree_id: { _eq: deep.idLocal('@deep-foundation/core', 'containTree') },
                parent: {
                    type_id: { _eq: deep.idLocal('@deep-foundation/core', 'Package') },
                    string: {}
                },
            },
        }), 'preloader');
    }), []);
    const _handlers = deep.useSubscription({
        execution_provider_id: { _eq: deep.idLocal('@deep-foundation/core', 'JSExecutionProvider') },
        return: {
            dist: { relation: 'dist' }
        },
    }, { table: 'handlers' });
    useEffect(() => {
        var _a;
        if (!!((_a = _handlers === null || _handlers === void 0 ? void 0 : _handlers.data) === null || _a === void 0 ? void 0 : _a.length))
            setHandlers(_handlers === null || _handlers === void 0 ? void 0 : _handlers.data);
    }, [_handlers]);
    const value = useMemo(() => ([isPreloaded, reload]), [isPreloaded]);
    const handlersRef = useRef(handlers);
    handlersRef.current = handlers;
    return React.createElement(PreloadContext.Provider, { value: value },
        React.createElement(HandlersContext.Provider, { value: handlersRef }, children));
}
export function PreloadProvider({ preloaded = {}, Editor, children = null, }) {
    const deep = useDeep();
    return React.createElement(GoEditorProvider, { Editor: Editor },
        deep ? [React.createElement(PreloadProviderCore, { key: deep.linkId, preloaded: preloaded, children: children })] : children,
        ";");
}
export function useSymbol() {
    const deep = useDeep();
    return (link) => symbol(link, deep);
}
export function symbol(link, deep) {
    var _a, _b, _c, _d;
    return (_d = (_c = (_b = (_a = link === null || link === void 0 ? void 0 : link.type) === null || _a === void 0 ? void 0 : _a.inByType[deep.idLocal('@deep-foundation/core', 'Symbol')]) === null || _b === void 0 ? void 0 : _b[0]) === null || _c === void 0 ? void 0 : _c.value) === null || _d === void 0 ? void 0 : _d.value;
}
export const loader = ({ query = { limit: 30 }, deep }) => {
    return Object.assign(Object.assign({ order_by: { id: 'desc' }, limit: 30 }, query), { return: Object.assign(Object.assign({}, ((query === null || query === void 0 ? void 0 : query.return) || {})), { names: {
                relation: 'in',
                type_id: deep.idLocal('@deep-foundation/core', 'Contain'),
                return: {
                    parent: { relation: 'from' },
                },
            }, from: { relation: 'from' }, to: { relation: 'to' } }) });
};
export function useLoader({ query, ref, interval = 10000 }) {
    const deep = useDeep();
    const q = useMemo(() => {
        return loader({ query, deep });
    }, [query, deep]);
    const results = deep.useQuery(q);
    const refResults = useRef(results);
    refResults.current = results;
    useEffect(() => {
        const i = setInterval(() => __awaiter(this, void 0, void 0, function* () {
            var style = ((ref === null || ref === void 0 ? void 0 : ref.current) ? window.getComputedStyle(ref === null || ref === void 0 ? void 0 : ref.current) : undefined) || undefined;
            return ((style === null || style === void 0 ? void 0 : style.display) !== 'none') && (yield refResults.current.refetch());
        }), interval);
        return () => clearInterval(i);
    }, []);
    return results;
}
export function useCanByContain(id) {
    const deep = useDeep();
    const { data } = deep.useQuery({
        id: id,
        up: {
            tree_id: deep.idLocal('@deep-foundation/core', 'containTree'),
            parent: {
                up: {
                    tree_id: deep.idLocal('@deep-foundation/core', 'joinTree'),
                    parent: {
                        down: {
                            tree_id: deep.idLocal('@deep-foundation/core', 'containTree'),
                            link_id: id
                        }
                    }
                }
            },
        },
    });
    return !!(data === null || data === void 0 ? void 0 : data.length);
}
export function useChakraColor(color) {
    const theme = useTheme();
    return getChakraColor(theme, color);
}
export function getChakraColor(theme, color) {
    var _a, _b;
    return ((_b = (_a = theme.__cssMap) === null || _a === void 0 ? void 0 : _a[`colors.${color}`]) === null || _b === void 0 ? void 0 : _b.value) || color;
}
export function getChakraVar(e, v) {
    return v && typeof (window) === 'object' && window.getComputedStyle(e) ? (window.getComputedStyle(e).getPropertyValue(v.slice(4, -1)) || v) : (v || 'transparent');
}
export function useChakraVar() {
    const theme = useTheme();
    const go = useGoCore();
    return (color) => {
        return getChakraVar(go().root().ref.current, getChakraColor(theme, color));
    };
}
//# sourceMappingURL=hooks.js.map